use crate::scanner::Scanner;
use crate::scanner::TokenType;

pub fn compile(source: &str) {
    let mut scanner: Scanner = Scanner::new(source);
    let mut line = 0;
    loop {
        let token = scanner.scan_token();

        if token.line != line {
            print!("{:4}", token.line);
            line = token.line;
        } else {
            print!("   |");
        }

        println!(
            ":{:<3} {:20} {:20}",
            token.start, token.token_type, token.lexeme
        );

        if let TokenType::TokenEof = token.token_type {
            break;
        }
    }
}
